package ch.fritteli.maze.generator.renderer.pdf;

import ch.fritteli.maze.generator.model.Maze;
import ch.fritteli.maze.generator.renderer.Renderer;
import java.io.ByteArrayOutputStream;

import lombok.NonNull;

public class PDFRenderer implements Renderer<ByteArrayOutputStream> {
    static final float MARGIN = 10;
    static final float SCALE = 10;

    private PDFRenderer() {
    }

    @NonNull
    public static PDFRenderer newInstance() {
        return new PDFRenderer();
    }

    @NonNull
    @Override
    public ByteArrayOutputStream render(@NonNull final Maze maze) {
        final Generator generator = new Generator(maze);
        return generator.generate();
    }
}
