package ch.fritteli.maze.generator.serialization.v1;

import ch.fritteli.maze.generator.algorithm.RandomDepthFirst;
import ch.fritteli.maze.generator.model.Maze;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;

class SerializerDeserializerV1Test {
    @Test
    void testSerializeDeserializeTiny() {
        final Maze expected = new Maze(2, 2, 255);
        new RandomDepthFirst(expected).run();
        final byte[] bytes = SerializerDeserializerV1.serialize(expected);
        final Maze result = SerializerDeserializerV1.deserialize(bytes);
        assertThat(result).isEqualTo(expected);
    }

    @Test
    void testSerializeDeserializeMedium() {
        final Maze expected = new Maze(20, 20, -271828182846L);
        new RandomDepthFirst(expected).run();
        final byte[] bytes = SerializerDeserializerV1.serialize(expected);
        final Maze result = SerializerDeserializerV1.deserialize(bytes);
        assertThat(result).isEqualTo(expected);
    }

    @Test
    void testSerializeDeserializeLarge() {
        final Maze expected = new Maze(200, 320, 3141592653589793238L);
        new RandomDepthFirst(expected).run();
        final byte[] bytes = SerializerDeserializerV1.serialize(expected);
        final Maze result = SerializerDeserializerV1.deserialize(bytes);
        assertThat(result).isEqualTo(expected);
    }
}
